Subject: Re: [PATCH 1/24] make atomic_read() behave consistently on alpha

From: Andi Kleen <[email-masked]>
Date: Fri, 10 Aug 2007 11:08:20 +0200

On Friday 10 August 2007 10:21:46 Herbert Xu wrote:
> Paul E. McKenney <[email-masked]> wrote:
> >
> > The compiler is within its rights to read a 32-bit quantity 16 bits at
> > at time, even on a 32-bit machine.  I would be glad to help pummel any
> > compiler writer that pulls such a dirty trick, but the C standard really
> > does permit this.
> 
> Code all over the kernel assumes that 32-bit reads/writes
> are atomic so while such a compiler might be legal it certainly
> can't compile Linux.

Yes, the kernel requirements are much stricter than ISO-C. And besides
it is a heavy user of C extensions anyways. On the other hand some of the
C99 extensions are not allowed. And then there is sparse, which enforces
a language which sometimes is quite far from standard C. You could say it is 
written in Linux-C, not ISO C. 

-Andi